Index: c/src/lib/libbsp/i386/i386ex/ChangeLog
===================================================================
--- c/src/lib/libbsp/i386/i386ex/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/i386/i386ex/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/i386/i386ex/timer/timer.c
===================================================================
--- c/src/lib/libbsp/i386/i386ex/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/i386/i386ex/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,17 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes the timer on the FORCE CPU-386 board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: This routine will not work if the optimizer is enabled
- *        for some compilers.  The multiple writes to the Z8036
- *        may be optimized away.
- *
- *        It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*  
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/i386/ts_386ex/ChangeLog
===================================================================
--- c/src/lib/libbsp/i386/ts_386ex/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/i386/ts_386ex/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/i386/ts_386ex/timer/timer.c
===================================================================
--- c/src/lib/libbsp/i386/ts_386ex/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/i386/ts_386ex/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,17 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes the timer on the FORCE CPU-386 board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: This routine will not work if the optimizer is enabled
- *        for some compilers.  The multiple writes to the Z8036
- *        may be optimized away.
- *
- *        It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/m68k/gen68302/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/gen68302/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68302/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/gen68302/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/gen68302/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68302/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,13 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes TIMER 2 for an MC68302.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/m68k/gen68340/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/gen68340/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68340/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/gen68340/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/gen68340/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68340/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,5 +1,3 @@
 /*
- * Timer_init()
- *
  * ATTENTION: AS MC68349 has no built-in Timer, the following code doesn't work
  * 	      in a MC68349. You can't use FIFO full mode for the moment, but
Index: c/src/lib/libbsp/m68k/gen68360/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68360/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/gen68360/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/gen68360/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,7 +1,4 @@
 /*
- * Timer_init()
- *
  * Use TIMER 1 and TIMER 2 for Timing Test Suite
- *
  * The hardware on the MC68360 makes these routines very simple.
  *
Index: c/src/lib/libbsp/m68k/idp/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/idp/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/idp/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/idp/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/idp/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/idp/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,17 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes the MC68230 timer on the Motorola IDP board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: This routine will not work if the optimizer is enabled
- *        for some compilers.  The multiple writes to the MC68230
- *        may be optimized away.
- *
- *        It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/* 
  *  Code Modified for the MC68230 by Doug McBride, Colorado Space Grant College
  *
Index: c/src/lib/libbsp/m68k/mrm332/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mrm332/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mrm332/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/mrm332/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/mrm332/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mrm332/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,13 +1,3 @@
-/*  Timer_init()
- *
- *  This routine is not implemented for this BSP.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/m68k/mvme136/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme136/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/mvme136/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme136/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,17 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes the Z8036 timer on the MVME136 board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: This routine will not work if the optimizer is enabled
- *        for some compilers.  The multiple writes to the Z8036
- *        may be optimized away.
- *
- *        It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/m68k/mvme147/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mvme147/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme147/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/mvme147/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/mvme147/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme147/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,13 +1,3 @@
-/*  Timer_init()
- *
- *  This routine initializes the PCC timer on the MVME147 board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
- *
+/*
  *  COPYRIGHT (c) 1989-1999.
  *  On-Line Applications Research Corporation (OAR).
Index: c/src/lib/libbsp/m68k/mvme162/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme162/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-30	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/mvme162/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/mvme162/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,16 +1,4 @@
-/*  Timer_init()
- *
+/*
  *  This routine initializes the Tick Timer 1 on the MVME162 board.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: This routine will not work if the optimizer is enabled
- *        for some compilers.  The multiple writes
- *        may be optimized away.
- *
- *        It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
  *
  *  COPYRIGHT (c) 1989-1999.
Index: c/src/lib/libbsp/m68k/ods68302/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/ods68302/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-29	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/m68k/ods68302/timer/timer.c
===================================================================
--- c/src/lib/libbsp/m68k/ods68302/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/m68k/ods68302/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,12 +1,5 @@
-/*  Timer_init()
+/*
  *
  *  This routine initializes TIMER 2 for an MC68302.
- *
- *  Input parameters:  NONE
- *
- *  Output parameters:  NONE
- *
- *  NOTE: It is important that the timer start/stop overhead be
- *        determined when porting or modifying this code.
  *
  *  COPYRIGHT (c) 1989-1999.
Index: c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/powerpc/tqm8xx/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-29	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/tqm8xx/timer/timer.c
===================================================================
--- c/src/lib/libbsp/powerpc/tqm8xx/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libbsp/powerpc/tqm8xx/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -22,5 +22,5 @@
 \*===============================================================*/
 /*
- * Timer_init()
+ * benchmark_timer_initialize()
  *
  * Use TIMER 1 and TIMER 2 for Timing Test Suite
@@ -53,6 +53,8 @@
 #include <mpc8xx.h>
 
+bool benchmark_timer_find_average_overhead;
+
 void
-Timer_initialize (void)
+benchmark_timer_initialize (void)
 {
 	/*
@@ -85,6 +87,5 @@
  * Return timer value in microsecond units
  */
-int
-Read_timer (void)
+int benchmark_timer_read(void)
 {
   int retval;
@@ -94,16 +95,8 @@
 }
 
-/*
- * Empty function call used in loops to measure basic cost of looping
- * in Timing Test Suite.
- */
-rtems_status_code
-Empty_function (void)
+void benchmark_timer_disable_subtracting_average_overhead(
+  bool find_flag
+)
 {
-	return RTEMS_SUCCESSFUL;
+  benchmark_timer_find_average_overhead = find_flag;
 }
-
-void
-Set_find_average_overhead(bool find_flag)
-{
-}
Index: c/src/lib/libcpu/mips/ChangeLog
===================================================================
--- c/src/lib/libcpu/mips/ChangeLog	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libcpu/mips/ChangeLog	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -1,2 +1,6 @@
+2008-09-30	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* timer/timer.c: Eliminate uses of old benchmark timer names.
+
 2008-09-05	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libcpu/mips/timer/timer.c
===================================================================
--- c/src/lib/libcpu/mips/timer/timer.c	(revision 42650f0282b615397212df75fdcf68c161a7df3d)
+++ c/src/lib/libcpu/mips/timer/timer.c	(revision 290da88f5a3e1908c2d9ab234199650308591a0e)
@@ -54,9 +54,9 @@
 
 static bool benchmark_timer_find_average_overhead;
-static uint32_t   Timer_initial_value = 0;
+static uint32_t   benchmark_timer_initial_value = 0;
 
 void benchmark_timer_initialize( void )
 {
-   Timer_initial_value = mips_read_timer();
+   benchmark_timer_initial_value = mips_read_timer();
   /*
    *  Somehow start the timer
@@ -91,9 +91,9 @@
 
   clicks = mips_read_timer();   /* XXX: read some HW here */
-  if (clicks < Timer_initial_value)
+  if (clicks < benchmark_timer_initial_value)
   {
       clicks += TIMER_MAX_VALUE;
   }
-  clicks -= Timer_initial_value;
+  clicks -= benchmark_timer_initial_value;
 
   /*