Index: rtems/config/tools/rtems-binutils-head.cfg
===================================================================
--- rtems/config/tools/rtems-binutils-head.cfg	(revision 3d30ecae960152dd5a0e1be55de97dd46486ac53)
+++ rtems/config/tools/rtems-binutils-head.cfg	(revision 295f9e94b9f08bae31673de3ecf66dd12b25b7b6)
@@ -2,9 +2,9 @@
 %include %{_configdir}/base.cfg
 
-%define binutils_version 4180301
+%define binutils_version 8ca9c7e
 %define binutils_external 1
 %define binutils_expand_name sourceware-mirror-binutils-gdb-%{binutils_version}
 %source set binutils --rsb-file=%{binutils_expand_name}.tar.gz https://codeload.github.com/RTEMS/sourceware-mirror-binutils-gdb/tar.gz/%{binutils_version}
-%hash sha512 %{binutils_expand_name}.tar.gz 683075d5572f7d74b26c7f3f70af91a34f72e580e58d1e668694665e5e003dafb110c40c341d201257905755f7a2cbe3203f4e8ed9c8e1520c82aebbe2e8bc05
+%hash sha512 %{binutils_expand_name}.tar.gz eb3173e804b1ec93e99efddde11cbed5f0cd1ed24b715d1b77e4f7f66d7a09e849178be730f80aa6a8f7c377461961bc0ee4839b7964919c33ad7c78dde7e374
 
 %define with_deterministic_archives 1
Index: rtems/config/tools/rtems-gcc-10-newlib-head.cfg
===================================================================
--- rtems/config/tools/rtems-gcc-10-newlib-head.cfg	(revision 3d30ecae960152dd5a0e1be55de97dd46486ac53)
+++ rtems/config/tools/rtems-gcc-10-newlib-head.cfg	(revision 295f9e94b9f08bae31673de3ecf66dd12b25b7b6)
@@ -2,18 +2,18 @@
 %include %{_configdir}/base.cfg
 
-%define gcc_version c03f9f3
+%define gcc_version 1e151fb
 %define gcc_external 1
 %define gcc_expand_name gnu-mirror-gcc-%{gcc_version}
 %source set gcc --rsb-file=%{gcc_expand_name}.tar.gz https://codeload.github.com/RTEMS/gnu-mirror-gcc/tar.gz/%{gcc_version}
-%hash sha512 %{gcc_expand_name}.tar.gz 541c83ae0a92a25881566e12911d8a9387d7ca4ed56f583c918e8f996b9ca04a4162327e405897f2fe6f42ddc1d8d8aa25889e20fbf21b5243d8833c6b8504bb
+%hash sha512 %{gcc_expand_name}.tar.gz fc3e5e9f729469c9b307541298a0804502f494cbf57da21abc2cbacc0b519181bf92ce1450b4dbf60bb29441d567a60318159d4219e6460bf389c1b48590e894
 
 %patch add gcc -p1 https://devel.rtems.org/raw-attachment/ticket/4196/0001-gcov-Add-fprofile-info-section-support.patch
 %hash sha512 0001-gcov-Add-fprofile-info-section-support.patch 284c4eb2180e8a7dac600b5833da5d2f99568b7fc2f873c145665ef56ab72ca3e9ac3da1e8bc88e72dd229f02a28402770d82ddd7a1b836836ae00cdfd1d400f
 
-%define newlib_version 415fdd4
+%define newlib_version 9ad86f6
 %define newlib_external 1
 %define newlib_expand_name sourceware-mirror-newlib-cygwin-%{newlib_version}
 %source set newlib --rsb-file=newlib-%{newlib_version}.tar.gz https://codeload.github.com/RTEMS/sourceware-mirror-newlib-cygwin/tar.gz/%{newlib_version}
-%hash sha512 newlib-%{newlib_version}.tar.gz 2cbba7fcdf08f115f4b767783a0042bba3c7b281dd66556e200fe086db46469f2b8b66b48e4170f63331e41858349f5dcc7778b643e23fab347fd364f8d19ec8
+%hash sha512 newlib-%{newlib_version}.tar.gz cff1ceb10b5b3f7af40bd5f1098a123a387a774f186400b2cfeed438f5ded84b56c5c4ea4261daddea025f17d008d90e8ef46982f29432e91e3c59ed08382915
 
 %define with_threads 1
Index: rtems/config/tools/rtems-gcc-head-newlib-head.cfg
===================================================================
--- rtems/config/tools/rtems-gcc-head-newlib-head.cfg	(revision 3d30ecae960152dd5a0e1be55de97dd46486ac53)
+++ rtems/config/tools/rtems-gcc-head-newlib-head.cfg	(revision 295f9e94b9f08bae31673de3ecf66dd12b25b7b6)
@@ -2,15 +2,15 @@
 %include %{_configdir}/base.cfg
 
-%define gcc_version 5d057bf
+%define gcc_version aa3d33d
 %define gcc_external 1
 %define gcc_expand_name gnu-mirror-gcc-%{gcc_version}
 %source set gcc --rsb-file=%{gcc_expand_name}.tar.gz https://codeload.github.com/RTEMS/gnu-mirror-gcc/tar.gz/%{gcc_version}
-%hash sha512 %{gcc_expand_name}.tar.gz adfe35c36d69a3642f4f45ccf9285ea721a6492b63aa19996911a4726c41878b61e6d39e3c342c87398c35767998ec2e677fd1416a4f93973d8b8e4b06970ed5
+%hash sha512 %{gcc_expand_name}.tar.gz faef2975daf90c1005ed305d8eaea48b3ce398a1ba8c06bc6624ce9ab72af806a2c85200c19f7d99ea2d90f2416992572e2d05af1b3fb7c042530a42e4dacda1
 
-%define newlib_version 415fdd4
+%define newlib_version 9ad86f6
 %define newlib_external 1
 %define newlib_expand_name sourceware-mirror-newlib-cygwin-%{newlib_version}
 %source set newlib --rsb-file=newlib-%{newlib_version}.tar.gz https://codeload.github.com/RTEMS/sourceware-mirror-newlib-cygwin/tar.gz/%{newlib_version}
-%hash sha512 newlib-%{newlib_version}.tar.gz 2cbba7fcdf08f115f4b767783a0042bba3c7b281dd66556e200fe086db46469f2b8b66b48e4170f63331e41858349f5dcc7778b643e23fab347fd364f8d19ec8
+%hash sha512 newlib-%{newlib_version}.tar.gz cff1ceb10b5b3f7af40bd5f1098a123a387a774f186400b2cfeed438f5ded84b56c5c4ea4261daddea025f17d008d90e8ef46982f29432e91e3c59ed08382915
 
 %define with_threads 1
Index: rtems/config/tools/rtems-gdb-head.cfg
===================================================================
--- rtems/config/tools/rtems-gdb-head.cfg	(revision 3d30ecae960152dd5a0e1be55de97dd46486ac53)
+++ rtems/config/tools/rtems-gdb-head.cfg	(revision 295f9e94b9f08bae31673de3ecf66dd12b25b7b6)
@@ -2,9 +2,9 @@
 %include %{_configdir}/base.cfg
 
-%define gdb_version 4180301
+%define gdb_version 8ca9c7e
 %define gdb_external 1
 %define gdb_expand_name sourceware-mirror-binutils-gdb-%{gdb_version}
 %source set gdb --rsb-file=%{gdb_expand_name}.tar.gz https://codeload.github.com/RTEMS/sourceware-mirror-binutils-gdb/tar.gz/%{gdb_version}
-%hash sha512 %{gdb_expand_name}.tar.gz 683075d5572f7d74b26c7f3f70af91a34f72e580e58d1e668694665e5e003dafb110c40c341d201257905755f7a2cbe3203f4e8ed9c8e1520c82aebbe2e8bc05
+%hash sha512 %{gdb_expand_name}.tar.gz eb3173e804b1ec93e99efddde11cbed5f0cd1ed24b715d1b77e4f7f66d7a09e849178be730f80aa6a8f7c377461961bc0ee4839b7964919c33ad7c78dde7e374
 
 %include %{_configdir}/gdb-8-1.cfg