Index: testsuites/sptests/ChangeLog
===================================================================
--- testsuites/sptests/ChangeLog	(revision 9f61efdaa79fa71c9847c68ae1ec1394fafecb20)
+++ testsuites/sptests/ChangeLog	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -1,2 +1,11 @@
+2010-06-26	Bharath Suri <bharath.s.jois@gmail.com>
+
+	PR 1592/testing
+	* Makefile.am, configure.ac: Changes to incorporate sperror01,
+	sperror02, sperror03
+	* sperror01/init.c, sperror02/init.c: New tests to exercise
+	rtems_error routine
+	* sperror03/init.c: New test to exercise rtems_panic routine
+
 2010-06-28	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: testsuites/sptests/Makefile.am
===================================================================
--- testsuites/sptests/Makefile.am	(revision 9f61efdaa79fa71c9847c68ae1ec1394fafecb20)
+++ testsuites/sptests/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -18,4 +18,5 @@
     spchain spclockget spcoverage spobjgetnext spnotepad01 spprintk spsize \
     spstkalloc spthreadq01 spwatchdog spwkspace \
+    sperror01 sperror02 sperror03 \
     spfatal01 spfatal02 spfatal03 spfatal04 spfatal05 spfatal06 spfatal07 \
     spfatal08 spfatal09 spfatal10 spfatal11 spfatal12 spfatal13 spfatal14 \
Index: testsuites/sptests/configure.ac
===================================================================
--- testsuites/sptests/configure.ac	(revision 9f61efdaa79fa71c9847c68ae1ec1394fafecb20)
+++ testsuites/sptests/configure.ac	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -101,4 +101,7 @@
 spclockget/Makefile
 spcoverage/Makefile
+sperror01/Makefile
+sperror02/Makefile
+sperror03/Makefile
 spfatal01/Makefile
 spfatal02/Makefile
Index: testsuites/sptests/sperror01/.cvsignore
===================================================================
--- testsuites/sptests/sperror01/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror01/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: testsuites/sptests/sperror01/Makefile.am
===================================================================
--- testsuites/sptests/sperror01/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror01/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,26 @@
+##
+## $Id$
+##
+
+MANAGERS = all
+
+rtems_tests_PROGRAMS = sperror01
+sperror01_SOURCES = init.c
+
+dist_rtems_tests_DATA = sperror01.scn
+dist_rtems_tests_DATA += sperror01.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(sperror01_OBJECTS) $(sperror01_LDADD)
+LINK_LIBS = $(sperror01_LDLIBS)
+
+sperror01$(EXEEXT): $(sperror01_OBJECTS) $(sperror01_DEPENDENCIES)
+	@rm -f sperror01$(EXEEXT)
+	$(make-exe)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/sptests/sperror01/init.c
===================================================================
--- testsuites/sptests/sperror01/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror01/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,54 @@
+/*
+ *  COPYRIGHT (c) 1989-2010.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#include <tmacros.h>
+#include "test_support.h"
+#include "rtems/error.h"
+#include <errno.h>
+
+rtems_task Init(
+  rtems_task_argument argument
+)
+{
+  puts( "\n\n*** TEST Tests for error reporting routines - 01 ***" );
+
+  errno = -1;
+  rtems_error(RTEMS_ERROR_ERRNO, "Dummy: Resources unavailable");
+
+  errno = ENOMEM;
+  rtems_error(
+    RTEMS_NO_MEMORY | RTEMS_ERROR_ERRNO,
+    "Dummy: Resources unavailable"
+  );
+
+  puts( "Dummy: causing panic.. will print test end message, then..." );
+  puts( "       print various error messages" );
+  rtems_error(
+    RTEMS_NO_MEMORY | RTEMS_ERROR_PANIC,
+    "Dummy: Resources unavailable\n"
+    "*** END OF TEST Tests for error reporting routines - 01 ***\n"
+  );
+  
+  rtems_test_exit(0);
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TASKS             1
+#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+/* end of file */
Index: testsuites/sptests/sperror01/sperror01.scn
===================================================================
--- testsuites/sptests/sperror01/sperror01.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror01/sperror01.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,9 @@
+*** TEST Tests for error reporting routines - 01 ***
+Dummy: Resources unavailable (unknown errno=-1)
+Dummy: Resources unavailable (status: could not get enough memory) (errno: Not enough space)
+Dummy: causing panic.. will print test end message, then...
+       print various error messages
+Dummy: Resources unavailable
+*** END OF TEST Tests for error reporting routines - 01 ***
+ (status: could not get enough memory)
+fatal error, exiting
Index: testsuites/sptests/sperror02/.cvsignore
===================================================================
--- testsuites/sptests/sperror02/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror02/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: testsuites/sptests/sperror02/Makefile.am
===================================================================
--- testsuites/sptests/sperror02/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror02/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,26 @@
+##
+## $Id$
+##
+
+MANAGERS = all
+
+rtems_tests_PROGRAMS = sperror02
+sperror02_SOURCES = init.c
+
+dist_rtems_tests_DATA = sperror02.scn
+dist_rtems_tests_DATA += sperror02.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(sperror02_OBJECTS) $(sperror02_LDADD)
+LINK_LIBS = $(sperror02_LDLIBS)
+
+sperror02$(EXEEXT): $(sperror02_OBJECTS) $(sperror02_DEPENDENCIES)
+	@rm -f sperror02$(EXEEXT)
+	$(make-exe)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/sptests/sperror02/init.c
===================================================================
--- testsuites/sptests/sperror02/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror02/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,45 @@
+/*
+ *  COPYRIGHT (c) 1989-2010.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#include <tmacros.h>
+#include "test_support.h"
+#include <errno.h>
+#include <rtems/error.h>
+
+rtems_task Init(
+  rtems_task_argument argument
+)
+{
+  puts( "\n\n*** TEST Tests for error reporting routines - 02 ***" );
+
+  errno = ENOMEM;
+  rtems_error(
+    RTEMS_NO_MEMORY | RTEMS_ERROR_ABORT, 
+    "Dummy: Resources unavailable\n"
+    "*** END OF TEST Tests for error reporting routines - 02 ***\n"
+  );
+  
+
+  rtems_test_exit(0);
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TASKS             1
+#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+/* end of file */
Index: testsuites/sptests/sperror02/sperror02.scn
===================================================================
--- testsuites/sptests/sperror02/sperror02.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror02/sperror02.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,5 @@
+*** TEST Tests for error reporting routines - 02 ***
+Dummy: Resources unavailable
+*** END OF TEST Tests for error reporting routines - 02 ***
+ (status: could not get enough memory)
+fatal error, aborting
Index: testsuites/sptests/sperror03/.cvsignore
===================================================================
--- testsuites/sptests/sperror03/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror03/.cvsignore	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: testsuites/sptests/sperror03/Makefile.am
===================================================================
--- testsuites/sptests/sperror03/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror03/Makefile.am	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,26 @@
+##
+## $Id$
+##
+
+MANAGERS = all
+
+rtems_tests_PROGRAMS = sperror03
+sperror03_SOURCES = init.c
+
+dist_rtems_tests_DATA = sperror03.scn
+dist_rtems_tests_DATA += sperror03.doc
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
+
+AM_CPPFLAGS += -I$(top_srcdir)/../support/include
+
+LINK_OBJS = $(sperror03_OBJECTS) $(sperror03_LDADD)
+LINK_LIBS = $(sperror03_LDLIBS)
+
+sperror03$(EXEEXT): $(sperror03_OBJECTS) $(sperror03_DEPENDENCIES)
+	@rm -f sperror03$(EXEEXT)
+	$(make-exe)
+
+include $(top_srcdir)/../automake/local.am
Index: testsuites/sptests/sperror03/init.c
===================================================================
--- testsuites/sptests/sperror03/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror03/init.c	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,41 @@
+/*
+ *  COPYRIGHT (c) 1989-2010.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#include <tmacros.h>
+#include "test_support.h"
+
+rtems_task Init(
+  rtems_task_argument argument
+)
+{
+  puts( "\n\n*** TEST Tests for error reporting routines - 03 ***" );
+
+  rtems_panic(
+    "Dummy panic\n"
+    "*** END OF TEST Tests for error reporting routines - 03 ***\n"
+  );
+  
+
+  rtems_test_exit(0);
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
+
+#define CONFIGURE_MAXIMUM_TASKS             1
+#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+/* end of file */
Index: testsuites/sptests/sperror03/sperror03.scn
===================================================================
--- testsuites/sptests/sperror03/sperror03.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
+++ testsuites/sptests/sperror03/sperror03.scn	(revision 0308c028537c525225446005ef051db49a136ba8)
@@ -0,0 +1,5 @@
+*** TEST Tests for error reporting routines - 03 ***
+Dummy panic
+*** END OF TEST Tests for error reporting routines - 03 ***
+
+fatal error, exiting