Index: ChangeLog
===================================================================
--- ChangeLog	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ ChangeLog	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -1,2 +1,17 @@
+2002-10-29	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* aclocal/enable-bare.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-cxx.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-inlines.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-itron.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-multiprocessing.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-networking.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-posix.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-rdbg.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-rtemsbsp.m4: Improve quoting of AC_HELP_STRING.
+	* aclocal/enable-tests.m4: Improve quoting of AC_HELP_STRING.
+	(autoconf > 2.54 seems to have problems with the old form of
+	quoting).
+
 2002-10-28	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: aclocal/enable-bare.m4
===================================================================
--- aclocal/enable-bare.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-bare.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -2,5 +2,6 @@
 [
 AC_ARG_ENABLE(bare-cpu-cflags,
-AC_HELP_STRING([--enable-bare-cpu-cflags],[specify a particular cpu cflag (bare bsp specific)]),
+[AC_HELP_STRING([--enable-bare-cpu-cflags],
+[specify a particular cpu cflag (bare bsp specific)])],
 [case "${enableval}" in
   no) BARE_CPU_CFLAGS="" ;;
@@ -10,5 +11,6 @@
 
 AC_ARG_ENABLE(bare-cpu-model,
-AC_HELP_STRING([--enable-bare-cpu-model],[specify a particular cpu model (bare bsp specific)]),
+[AC_HELP_STRING([--enable-bare-cpu-model],
+[specify a particular cpu model (bare bsp specific)])],
 [case "${enableval}" in
   no)   BARE_CPU_MODEL="" ;;
Index: aclocal/enable-cxx.m4
===================================================================
--- aclocal/enable-cxx.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-cxx.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -4,6 +4,6 @@
 [
 AC_ARG_ENABLE(cxx,
-AC_HELP_STRING([--enable-cxx],[enable C++ support and build the rtems++
-library]),
+[AC_HELP_STRING([--enable-cxx],
+[enable C++ support and build the rtems++ library])],
 [case "${enableval}" in
   yes) RTEMS_HAS_CPLUSPLUS=yes ;;
Index: aclocal/enable-inlines.m4
===================================================================
--- aclocal/enable-inlines.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-inlines.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -3,5 +3,6 @@
 AC_DEFUN(RTEMS_ENABLE_INLINES,
 [AC_ARG_ENABLE(rtems-inlines,
-AC_HELP_STRING([--enable-rtems-inlines],[enable RTEMS inline functions (default:enabled, disable to use macros)]),
+[AC_HELP_STRING([--enable-rtems-inlines],
+[enable RTEMS inline functions (default:enabled, disable to use macros)])],
 [case "${enableval}" in
   yes) RTEMS_USE_MACROS=no ;;
Index: aclocal/enable-itron.m4
===================================================================
--- aclocal/enable-itron.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-itron.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,5 +6,5 @@
 
 AC_ARG_ENABLE(itron,
-AC_HELP_STRING([--enable-itron],[enable itron interface]),
+[AC_HELP_STRING([--enable-itron],[enable itron interface])],
 [case "${enableval}" in 
   yes) RTEMS_HAS_ITRON_API=yes ;;
Index: aclocal/enable-multiprocessing.m4
===================================================================
--- aclocal/enable-multiprocessing.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-multiprocessing.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -4,5 +4,6 @@
 [
 AC_ARG_ENABLE(multiprocessing,
-AC_HELP_STRING([--enable-multiprocessing],[enable multiprocessing interface]),
+[AC_HELP_STRING([--enable-multiprocessing],
+[enable multiprocessing interface])],
 [case "${enable_multiprocessing}" in 
   yes) ;;
Index: aclocal/enable-networking.m4
===================================================================
--- aclocal/enable-networking.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-networking.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,5 +6,5 @@
 
 AC_ARG_ENABLE(networking,
-AC_HELP_STRING([--enable-networking],[enable TCP/IP stack]),
+[AC_HELP_STRING([--enable-networking],[enable TCP/IP stack])],
 [case "${enableval}" in
   yes) RTEMS_HAS_NETWORKING=yes ;;
Index: aclocal/enable-posix.m4
===================================================================
--- aclocal/enable-posix.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-posix.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,5 +6,5 @@
 
 AC_ARG_ENABLE(posix,
-AC_HELP_STRING([--enable-posix],[enable posix interface]),
+[AC_HELP_STRING([--enable-posix],[enable posix interface])],
 [case "${enableval}" in 
   yes) RTEMS_HAS_POSIX_API=yes ;;
Index: aclocal/enable-rdbg.m4
===================================================================
--- aclocal/enable-rdbg.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-rdbg.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,5 +6,5 @@
 
 AC_ARG_ENABLE(rdbg,
-AC_HELP_STRING([--enable-rdbg],[enable remote debugger]),
+[AC_HELP_STRING([--enable-rdbg],[enable remote debugger])],
 [case "${enableval}" in
   yes) RTEMS_HAS_RDBG=yes ;;
Index: aclocal/enable-rtemsbsp.m4
===================================================================
--- aclocal/enable-rtemsbsp.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-rtemsbsp.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,8 +6,8 @@
 AC_DEFUN(RTEMS_ENABLE_RTEMSBSP,
 [
-AC_BEFORE([$0], [RTEMS_ENV_RTEMSBSP])dnl
+AC_BEFORE([$0], [RTEMS_ENV_RTEMSBSP])
 AC_ARG_ENABLE(rtemsbsp,
-AC_HELP_STRING([--enable-rtemsbsp="bsp1 bsp2 .."],
-[BSPs to include in build]),
+[AC_HELP_STRING([--enable-rtemsbsp="bsp1 bsp2 .."],
+[BSPs to include in build])],
 [case "${enableval}" in
   yes|no) AC_MSG_ERROR([missing argument to --enable-rtemsbsp="bsp1 bsp2"]);;
Index: aclocal/enable-tests.m4
===================================================================
--- aclocal/enable-tests.m4	(revision 1da0c520815c72986cb434ae8e18802007902437)
+++ aclocal/enable-tests.m4	(revision 314a962f43cf6582ab0a5076418cc0bf5af28d3e)
@@ -6,5 +6,5 @@
 AC_MSG_CHECKING([if the test suites are enabled? ])
 AC_ARG_ENABLE(tests,
-AC_HELP_STRING([--enable-tests],[enable tests (default:disabled)]),
+[AC_HELP_STRING([--enable-tests],[enable tests (default:disabled)])],
   [case "${enableval}" in
     yes) tests_enabled=yes ;;