Index: doc/itron3.0/semaphore.t
===================================================================
--- doc/itron3.0/semaphore.t	(revision b1b4fd26d0f10a9415a2bc1fc062bad7bda4bcd2)
+++ doc/itron3.0/semaphore.t	(revision 315b929d287967a434cf3e09df1d9849cf549841)
@@ -75,6 +75,6 @@
 @item sematr
 is the attributes for this semaphore.  The only attributed
-which can be specified is whether tasks wait in FIFO (default)
-or priority order.
+which can be specified is whether tasks wait in FIFO (@code{TA_TFIFO})
+or priority (@code{TA_TPRI}) order.
 
 @item isemcnt
@@ -162,31 +162,40 @@
 @code{E_OK} - Normal Completion
 
-@code{E_NOMEM} - Insufficient memory (Memory for control block cannot be allocated)
-
-@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
-
-@code{E_RSATR} - Reserved attribute (sematr was invalid or could not be used)
-
-@code{E_OBJ} - Invalid object state (a semaphore of the same ID already exists)
-
-@code{E_OACV} - Object access violation (A semid less than -4 was specified from a user task.  This is implementation dependent.)
-
-@code{E_PAR} - Parameter error (pk_csem is invalid and/or isemcnt or maxsem is negative or invalid)
-
-@code{EN_OBJNO} - An object number which could not be accessed on the target node is specified.
-
-@code{EN_CTXID} - Specified an object on another node when the system call was
-issued from a task in dispatch disabled state or from a task-
+@code{E_NOMEM} - Insufficient memory (Memory for control block cannot be
+allocated)
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_RSATR} - Reserved attribute (sematr was invalid or could not be
+used)
+
+@code{E_OBJ} - Invalid object state (a semaphore of the same ID already
+exists)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_PAR} - Parameter error (pk_csem is invalid and/or isemcnt or
+maxsem is negative or invalid)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_CTXID} - Specified an object on another node when the system call
+was issued from a task in dispatch disabled state or from a task-
 independent portion
 
-@code{EN_PAR} - A value outside the range supported by the target node and/or
-transmission packet format was specified as a parameter (a value
-outside supported range was specified for exinf, sematr, isemcnt
-and/or maxsem)
-
-@subheading DESCRIPTION:
-
-@subheading NOTES:
-
+@code{EN_PAR} - A value outside the range supported by the target node
+and/or transmission packet format was specified as a parameter (a value
+outside supported range was specified for exinf, sematr, isemcnt and/or
+maxsem)
+
+@subheading DESCRIPTION:
+
+
+
+@subheading NOTES:
+
+NONE
 
 
@@ -215,5 +224,25 @@
 @subheading DESCRIPTION:
 
-@subheading NOTES:
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_CTXID} - Specified an object on another node when the system call
+was issued from a task in dispatch disabled state or from a
+task-independent portion
+
+
+@subheading NOTES:
+
+NONE
 
 
@@ -240,7 +269,29 @@
 @subheading STATUS CODES:
 
-@subheading DESCRIPTION:
-
-@subheading NOTES:
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_QOVR} - Queuing or nesting overflow (the queuing count given by
+semcnt went over the maximum allowed)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_CTXID} - Specified an object on another node when the system call
+was issued from a task in dispatch disabled state or from a
+task-independent portion
+
+@subheading DESCRIPTION:
+
+@subheading NOTES:
+
+NONE
 
 
@@ -267,7 +318,40 @@
 @subheading STATUS CODES:
 
-@subheading DESCRIPTION:
-
-@subheading NOTES:
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_PAR} - Parameter error (tmout is -2 or less)
+
+@code{E_DLT} - The object being waited for was deleted (the specified
+semaphore was deleted while waiting)
+
+@code{E_RLWAI} - Wait state was forcibly released (rel_wai was received
+while waiting)
+
+@code{E_TMOUT} - Polling failure or timeout exceeded
+
+@code{E_CTX} - Context error (issued from task-independent portions or a
+task in dispatch disabled state)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_PAR} - A value outside the range supported by the target node
+and/or transmission packet format was specified as a parameter (a value
+outside supported range was specified for tmout)
+
+
+@subheading DESCRIPTION:
+
+@subheading NOTES:
+
+NONE
 
 
@@ -294,7 +378,40 @@
 @subheading STATUS CODES:
 
-@subheading DESCRIPTION:
-
-@subheading NOTES:
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_PAR} - Parameter error (tmout is -2 or less)
+
+@code{E_DLT} - The object being waited for was deleted (the specified
+semaphore was deleted while waiting)
+
+@code{E_RLWAI} - Wait state was forcibly released (rel_wai was received
+while waiting)
+
+@code{E_TMOUT} - Polling failure or timeout exceeded
+
+@code{E_CTX} - Context error (issued from task-independent portions or a
+task in dispatch disabled state)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_PAR} - A value outside the range supported by the target node
+and/or transmission packet format was specified as a parameter (a value
+outside supported range was specified for tmout)
+
+
+@subheading DESCRIPTION:
+
+@subheading NOTES:
+
+NONE
 
 
@@ -322,7 +439,40 @@
 @subheading STATUS CODES:
 
-@subheading DESCRIPTION:
-
-@subheading NOTES:
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_PAR} - Parameter error (tmout is -2 or less)
+
+@code{E_DLT} - The object being waited for was deleted (the specified
+semaphore was deleted while waiting)
+
+@code{E_RLWAI} - Wait state was forcibly released (rel_wai was received
+while waiting)
+
+@code{E_TMOUT} - Polling failure or timeout exceeded
+
+@code{E_CTX} - Context error (issued from task-independent portions or a
+task in dispatch disabled state)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_PAR} - A value outside the range supported by the target node
+and/or transmission packet format was specified as a parameter (a value
+outside supported range was specified for tmout)
+
+
+@subheading DESCRIPTION:
+
+@subheading NOTES:
+
+NONE
 
 
@@ -350,6 +500,32 @@
 @subheading STATUS CODES:
 
-@subheading DESCRIPTION:
-
-@subheading NOTES:
-
+@code{E_OK} - Normal Completion
+
+@code{E_ID} - Invalid ID number (semid was invalid or could not be used)
+
+@code{E_NOEXS} - Object does not exist (the semaphore specified by semid
+does not exist)
+
+@code{E_OACV} - Object access violation (A semid less than -4 was
+specified from a user task.  This is implementation dependent.)
+
+@code{E_PAR} - Parameter error (the packet address for the return
+parameters could not be used)
+
+@code{EN_OBJNO} - An object number which could not be accessed on the
+target node is specified.
+
+@code{EN_CTXID} - Specified an object on another node when the system call
+was issued from a task in dispatch disabled state or from a
+task-independent portion
+
+@code{EN_RPAR} - A value outside the range supported by the requesting
+node and/or transmission packet format was returned as a parameter (a
+value outside supported range was specified for exinf, wtsk or semcnt)
+
+@subheading DESCRIPTION:
+
+@subheading NOTES:
+
+NONE
+