Index: c/src/tests/psxtests/psxhdrs/pthread32.c
===================================================================
--- c/src/tests/psxtests/psxhdrs/pthread32.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ c/src/tests/psxtests/psxhdrs/pthread32.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,35 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREADS
+#error "rtems is supposed to have pthread_cleanup_push"
+#endif
+
+void cleanup_routine(
+  void *argument
+)
+{
+}
+
+void test( void )
+{
+  int argument;
+
+  argument = 0;
+
+  pthread_cleanup_push( cleanup_routine, &argument );
+}
Index: c/src/tests/psxtests/psxhdrs/pthread33.c
===================================================================
--- c/src/tests/psxtests/psxhdrs/pthread33.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ c/src/tests/psxtests/psxhdrs/pthread33.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,25 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREADS
+#error "rtems is supposed to have pthread_cleanup_pop"
+#endif
+
+void test( void )
+{
+  pthread_cleanup_pop( 1 );
+}
Index: c/src/tests/psxtests/psxhdrs/pthread34.c
===================================================================
--- c/src/tests/psxtests/psxhdrs/pthread34.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ c/src/tests/psxtests/psxhdrs/pthread34.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,31 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_getcpuclockid"
+#endif
+
+void test( void )
+{
+  pthread_t  thread;
+  clockid_t  clock_id;
+  int        result;
+
+  thread = 0;
+
+  result = pthread_getcpuclockid( thread, &clock_id );
+}
Index: c/src/tests/psxtests/psxhdrs/pthread35.c
===================================================================
--- c/src/tests/psxtests/psxhdrs/pthread35.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ c/src/tests/psxtests/psxhdrs/pthread35.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,32 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_attr_setcputime"
+#endif
+
+void test( void )
+{
+  pthread_attr_t  attr;
+  int             clock_allowed;
+  int             result;
+
+  clock_allowed = CLOCK_ALLOWED;
+  clock_allowed = CLOCK_DISALLOWED;
+
+  result = pthread_attr_setcputime( &attr, clock_allowed );
+}
Index: c/src/tests/psxtests/psxhdrs/pthread36.c
===================================================================
--- c/src/tests/psxtests/psxhdrs/pthread36.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ c/src/tests/psxtests/psxhdrs/pthread36.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,29 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_attr_getcputime"
+#endif
+
+void test( void )
+{
+  pthread_attr_t  attr;
+  int             clock_allowed;
+  int             result;
+
+  result = pthread_attr_getcputime( &attr, &clock_allowed );
+}
Index: testsuites/psxtests/psxhdrs/pthread32.c
===================================================================
--- testsuites/psxtests/psxhdrs/pthread32.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ testsuites/psxtests/psxhdrs/pthread32.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,35 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREADS
+#error "rtems is supposed to have pthread_cleanup_push"
+#endif
+
+void cleanup_routine(
+  void *argument
+)
+{
+}
+
+void test( void )
+{
+  int argument;
+
+  argument = 0;
+
+  pthread_cleanup_push( cleanup_routine, &argument );
+}
Index: testsuites/psxtests/psxhdrs/pthread33.c
===================================================================
--- testsuites/psxtests/psxhdrs/pthread33.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ testsuites/psxtests/psxhdrs/pthread33.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,25 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREADS
+#error "rtems is supposed to have pthread_cleanup_pop"
+#endif
+
+void test( void )
+{
+  pthread_cleanup_pop( 1 );
+}
Index: testsuites/psxtests/psxhdrs/pthread34.c
===================================================================
--- testsuites/psxtests/psxhdrs/pthread34.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ testsuites/psxtests/psxhdrs/pthread34.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,31 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_getcpuclockid"
+#endif
+
+void test( void )
+{
+  pthread_t  thread;
+  clockid_t  clock_id;
+  int        result;
+
+  thread = 0;
+
+  result = pthread_getcpuclockid( thread, &clock_id );
+}
Index: testsuites/psxtests/psxhdrs/pthread35.c
===================================================================
--- testsuites/psxtests/psxhdrs/pthread35.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ testsuites/psxtests/psxhdrs/pthread35.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,32 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_attr_setcputime"
+#endif
+
+void test( void )
+{
+  pthread_attr_t  attr;
+  int             clock_allowed;
+  int             result;
+
+  clock_allowed = CLOCK_ALLOWED;
+  clock_allowed = CLOCK_DISALLOWED;
+
+  result = pthread_attr_setcputime( &attr, clock_allowed );
+}
Index: testsuites/psxtests/psxhdrs/pthread36.c
===================================================================
--- testsuites/psxtests/psxhdrs/pthread36.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
+++ testsuites/psxtests/psxhdrs/pthread36.c	(revision 318ac690297b9f730ec2c1ade3e658445ea505ea)
@@ -0,0 +1,29 @@
+/*
+ *  This test file is used to verify that the header files associated with
+ *  the callout are correct.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <pthread.h>
+ 
+#ifndef _POSIX_THREAD_CPUTIME
+#error "rtems is supposed to have pthread_attr_getcputime"
+#endif
+
+void test( void )
+{
+  pthread_attr_t  attr;
+  int             clock_allowed;
+  int             result;
+
+  result = pthread_attr_getcputime( &attr, &clock_allowed );
+}