Index: testsuites/smptests/ChangeLog
===================================================================
--- testsuites/smptests/ChangeLog	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/ChangeLog	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -1,2 +1,10 @@
+2011-12-08	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	PR 1589/build
+	* smp01/Makefile.am, smp02/Makefile.am, smp03/Makefile.am,
+	smp04/Makefile.am, smp05/Makefile.am, smp06/Makefile.am,
+	smp07/Makefile.am, smp08/Makefile.am, smp09/Makefile.am: Remove
+	obsolete optional manager capability.
+
 2011-09-29	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: testsuites/smptests/smp01/Makefile.am
===================================================================
--- testsuites/smptests/smp01/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp01/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp01
@@ -18,5 +17,5 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-LINK_OBJS = $(smp01_OBJECTS) $(smp01_LDADD)
+LINK_OBJS = $(smp01_OBJECTS)
 LINK_LIBS = $(smp01_LDLIBS)
 
Index: testsuites/smptests/smp02/Makefile.am
===================================================================
--- testsuites/smptests/smp02/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp02/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp02
@@ -18,7 +17,6 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-smp02_LDADD = $(MANAGERS_NOT_WANTED:%=$(PROJECT_LIB)/no-%.rel)
 
-LINK_OBJS = $(smp02_OBJECTS) $(smp02_LDADD)
+LINK_OBJS = $(smp02_OBJECTS)
 LINK_LIBS = $(smp02_LDLIBS)
 
Index: testsuites/smptests/smp03/Makefile.am
===================================================================
--- testsuites/smptests/smp03/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp03/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp03
@@ -18,7 +17,6 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-smp03_LDADD = $(MANAGERS_NOT_WANTED:%=$(PROJECT_LIB)/no-%.rel)
 
-LINK_OBJS = $(smp03_OBJECTS) $(smp03_LDADD)
+LINK_OBJS = $(smp03_OBJECTS)
 LINK_LIBS = $(smp03_LDLIBS)
 
Index: testsuites/smptests/smp04/Makefile.am
===================================================================
--- testsuites/smptests/smp04/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp04/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp04
@@ -18,7 +17,6 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-smp04_LDADD = $(MANAGERS_NOT_WANTED:%=$(PROJECT_LIB)/no-%.rel)
 
-LINK_OBJS = $(smp04_OBJECTS) $(smp04_LDADD)
+LINK_OBJS = $(smp04_OBJECTS)
 LINK_LIBS = $(smp04_LDLIBS)
 
Index: testsuites/smptests/smp05/Makefile.am
===================================================================
--- testsuites/smptests/smp05/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp05/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp05
@@ -18,5 +17,5 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-LINK_OBJS = $(smp05_OBJECTS) $(smp05_LDADD)
+LINK_OBJS = $(smp05_OBJECTS)
 LINK_LIBS = $(smp05_LDLIBS)
 
Index: testsuites/smptests/smp06/Makefile.am
===================================================================
--- testsuites/smptests/smp06/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp06/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp06
@@ -18,5 +17,5 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-LINK_OBJS = $(smp06_OBJECTS) $(smp06_LDADD)
+LINK_OBJS = $(smp06_OBJECTS)
 LINK_LIBS = $(smp06_LDLIBS)
 
Index: testsuites/smptests/smp07/Makefile.am
===================================================================
--- testsuites/smptests/smp07/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp07/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp07
@@ -18,5 +17,5 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-LINK_OBJS = $(smp07_OBJECTS) $(smp07_LDADD)
+LINK_OBJS = $(smp07_OBJECTS)
 LINK_LIBS = $(smp07_LDLIBS)
 
Index: testsuites/smptests/smp08/Makefile.am
===================================================================
--- testsuites/smptests/smp08/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp08/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp08
@@ -18,7 +17,6 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-smp08_LDADD = $(MANAGERS_NOT_WANTED:%=$(PROJECT_LIB)/no-%.rel)
 
-LINK_OBJS = $(smp08_OBJECTS) $(smp08_LDADD)
+LINK_OBJS = $(smp08_OBJECTS)
 LINK_LIBS = $(smp08_LDLIBS)
 
Index: testsuites/smptests/smp09/Makefile.am
===================================================================
--- testsuites/smptests/smp09/Makefile.am	(revision cd06294a08d5f38eb6740506487006d0090deac6)
+++ testsuites/smptests/smp09/Makefile.am	(revision 341aaf8a77049b3a9e0c7230a4ac849c3c60c403)
@@ -3,5 +3,4 @@
 ##
 
-MANAGERS = all
 
 rtems_tests_PROGRAMS = smp09
@@ -18,5 +17,5 @@
 AM_CPPFLAGS += -DSMPTEST 
 
-LINK_OBJS = $(smp09_OBJECTS) $(smp09_LDADD)
+LINK_OBJS = $(smp09_OBJECTS)
 LINK_LIBS = $(smp09_LDLIBS)
 